#!/bin/bash -e

wd=$(pwd)
jobid=$(squeue --me | head -2 | tail -n1 | awk '{print $1}')


#
# Example assume allocation was created, e.g.:
# N=1 ; salloc -p standard-g  --threads-per-core 1 --exclusive -N $N --gpus $((N*8)) -t 4:00:00 --mem 0
#

module purge
module load CrayEnv
module load PrgEnv-cray/8.4.0
module load craype-accel-amd-gfx90a
module load cray-python

# This path provides more recent ROCm modules.
module use /pfs/lustrep2/projappl/project_462000125/samantao-public/mymodules
module load rocm/5.6.1.lua

set -x

# Install pytorch if it doesn't exist already.
if [ ! -d $wd/pip-installs ] ; then
    pip3 install -t $wd/pip-installs --pre torch==2.2.2+rocm5.6 --index-url https://download.pytorch.org/whl/
fi

PYTHONPATH=$wd/pip-installs \
    srun --jobid=$jobid -n1 --gpus 8 \
        python -c 'import torch; print("I have this many devices:", torch.cuda.device_count())'
