#!/bin/bash -e

wd=$(pwd)
jobid=$(squeue --me | head -2 | tail -n1 | awk '{print $1}')


#
# Example assume allocation was created, e.g.:
# N=1 ; salloc -p standard-g  --threads-per-core 1 --exclusive -N $N --gpus $((N*8)) -t 4:00:00 --mem 0
#

module purge
module load CrayEnv
module load PrgEnv-cray/8.4.0
module load craype-x86-trento
module load craype-accel-amd-gfx90a
module load cray-python

module use /pfs/lustrep2/projappl/project_462000125/samantao-public/mymodules
module load rocm/5.6.1.lua

set -x

# Install pytorch if it doesn't exist already.
if [ ! -d $wd/cray-python-virtualenv ] ; then
    python -m venv --system-site-packages cray-python-virtualenv
    source cray-python-virtualenv/bin/activate
    pip3 install --pre torch==2.2.2+rocm5.6 --index-url https://download.pytorch.org/whl/
else
    source cray-python-virtualenv/bin/activate
fi

srun --jobid=$jobid -n1 --gpus 8 \
    python -c 'import torch; print("I have this many devices:", torch.cuda.device_count())'
